''************************************
''*  Serial Monitor                  *
''*  for FullDuplexSereial128 '1.1b' *
''************************************
' 2008.11.27 Eric Ratliff, to see how full rx and tx buffers of full duplex serial are getting
' hard coded for 128 byte receive buffer

CON
  RX_BUF_SIZEp2 = 7                                     ' base 2 log of the size of the receive buffer
  RX_BUF_SIZE = 1 << RX_BUF_SIZEp2                      ' size of the receive buffer
  RX_BUF_REMAINDER_MASK = RX_BUF_SIZE - 1
VAR
  long  prx_head                ' pointers to indicies of where we are in the receive buffer
  long  prx_tail
  long  pCurrentRxUnused        ' most recent receive buffer status
  long  pMinRxUnused            ' worst receive buffer status
  long  pHeadValue
  long  pTailValue
  long  BufferContents
  long  pBufferContents
  long SerialMonitorStackLocal[30]

PUB CogRun(pSerialStruct, pReportAddress):CogNumber
  CogNumber := cognew(run(pSerialStruct,pReportAddress),@SerialMonitorStackLocal) ' start the serial monitor in its own cog

PUB run(pSerialStruct, pReportAddress)
'' continuously monitor remaining space in buffer, post results: current, minimum

  ' input addresses
  prx_head := pSerialStruct
  prx_tail := pSerialStruct + 4

  ' output addresses
  pHeadValue := pReportAddress
  pTailValue := pReportAddress + 4
  pBufferContents := pReportAddress + 8
  pCurrentRxUnused := pReportAddress + 12
  pMinRxUnused := pReportAddress + 16

  ' starting min value
  LONG[pMinRxUnused] := RX_BUF_SIZE
  
  repeat
{
    ' verbose debugging version
    LONG[pHeadValue] := LONG[prx_head]
    LONG[pTailValue] := LONG[prx_tail]
    LONG[pBufferContents] := (LONG[pHeadValue] - LONG[pTailValue]) & RX_BUF_REMAINDER_MASK ' subtract and do remainder for wrap
    LONG[pCurrentRxUnused] := RX_BUF_SIZE - LONG[pBufferContents]               ' subtract what's used to find what's not used
    LONG[pMinRxUnused] := LONG[pMinRxUnused] <# LONG[pCurrentRxUnused]          ' pick lowest of two numbers
}

    ' fast version
    'LONG[pHeadValue] := LONG[prx_head]
    'LONG[pTailValue] := LONG[prx_tail]
    'LONG[pBufferContents] := (LONG[prx_head] - LONG[prx_tail]) & RX_BUF_REMAINDER_MASK ' subtract and do remainder for wrap
    LONG[pCurrentRxUnused] := RX_BUF_SIZE - ((LONG[prx_head] - LONG[prx_tail]) & RX_BUF_REMAINDER_MASK) ' subtract what's used to find what's not used
    LONG[pMinRxUnused] := LONG[pMinRxUnused] <# LONG[pCurrentRxUnused]          ' pick lowest of two numbers